Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# gnDNXSource Class Reference

gnDNXSource implements the DNX file source. More...

`#include <gnDNXSource.h>`

Inheritance diagram for gnDNXSource:

List of all members.

## Public Member Functions
| gnDNXSource ()
| Empty Constructor, does nothing.
| gnDNXSource (const gnDNXSource &s)
| The copy constructor copies the given gnDNXSource.
| ~gnDNXSource ()
| Destructor, frees memory.
gnDNXSource * | Clone () const
uint32 | GetContigListLength () const
| Get the number of sequence contigs in this source.
boolean | HasContig (const string &name) const
| Looks for a contig by name.
uint32 | GetContigID (const string &name) const
| Get a contig index by name.
string | GetContigName (const uint32 i) const
| Get the name of the specified contig.
gnSeqI | GetContigSeqLength (const uint32 i) const
| Get the total number of base pairs in the specified contig.
boolean | SeqRead (const gnSeqI start, char *buf, uint32 &bufLen, const uint32 contigI=ALL_CONTIGS)
| Gets sequence data from this source.
gnGenomeSpec * | GetSpec () const
| Get the annotated sequence data as a gnGenomeSpec.
gnFileContig * | GetFileContig (const uint32 contigI) const
| Returns a pointer to the file contig corresponding to contigI or null if none exists.
virtual void | Open (string openString)
| Opens the source given in "openString" for reading.
virtual void | Open ()
| Opens this source for reading.
virtual void | Close ()
| Closes the file or connection this source is reading from.
virtual string | GetOpenString () const
| Get the location of the source that is being used.
virtual const gnFilter * | GetFilter () const
| Get the filter currently being used to filter unwanted characters out of read sequences.
virtual void | SetFilter (gnFilter *filter)
| Set the filter that will be used to filter unwanted characters out of the sequence data.
virtual boolean | Read (const uint64 pos, char *buf, uint32 &bufLen)
| Gets raw input from this source.
## Static Public Member Functions
boolean | Write (gnSequence &sequence, const string &filename)
| Writes the given gnSequence to a DNX file named "filename".
boolean | Write (gnBaseSource *source, const string &filename)
| This method is deprecated.
boolean | Write (gnGenomeSpec *spec, const string &filename)
| Writes the given gnGenomeSpec to a DNX file named "filename".
## Protected Member Functions
void | DetermineNewlineType ()
## Protected Attributes
string | m_openString
ifstream | m_ifstream
const gnFilter * | m_pFilter
gnNewlineType | m_newlineType
uint32 | m_newlineSize
## Private Member Functions
boolean | ParseStream (istream &fin)
## Static Private Member Functions
void | ValidateName (string &name)
## Private Attributes
gnGenomeSpec * | m_DNXSpec

## Detailed Description

gnDNXSource implements the DNX file source.

This class reads and writes the Blattner Lab DNX file format. DNX files may be written by calling: gnDNXSource::Write( mySpec, "C:\myFile.dnx");

Definition at line 35 of file gnDNXSource.h.

## Constructor & Destructor Documentation

gnDNXSource::gnDNXSource | ( |  | ) |

| Empty Constructor, does nothing. Definition at line 24 of file gnDNXSource.cpp. References DebugMsg(), gnFilter::fullDNASeqFilter(), m_DNXSpec, and gnFileSource::m_pFilter. Referenced by Clone().

gnDNXSource::gnDNXSource | ( | const gnDNXSource & | s | ) |

  | The copy constructor copies the given gnDNXSource. Parameters:
  s | A gnDNXSource to copy.
Definition at line 33 of file gnDNXSource.cpp. References gnGenomeSpec::Clone(), and m_DNXSpec.

gnDNXSource::~gnDNXSource | ( |  | ) |

| Destructor, frees memory. Definition at line 39 of file gnDNXSource.cpp. References m_DNXSpec, and gnFileSource::m_ifstream.

## Member Function Documentation

gnDNXSource * gnDNXSource::Clone | ( |  | ) | const`[inline, virtual]`

| Implements gnFileSource. Definition at line 101 of file gnDNXSource.h. References gnDNXSource().

void gnFileSource::Close | ( |  | ) | `[virtual, inherited]`

  | Closes the file or connection this source is reading from. Exceptions:
  IOStreamError | if an error occurs closing the file.
Implements gnBaseSource. Definition at line 56 of file gnFileSource.cpp. References IOStreamFailed(), gnFileSource::m_ifstream, and Throw_gnEx.

void gnFileSource::DetermineNewlineType | ( |  | ) | `[protected, inherited]`

| Definition at line 74 of file gnFileSource.cpp. References gnNewlineMac, gnNewlineUnix, gnNewlineWindows, gnFileSource::m_ifstream, gnFileSource::m_newlineSize, and gnFileSource::m_newlineType. Referenced by gnGBKSource::ParseStream(), and gnFASSource::ParseStream().

uint32 gnDNXSource::GetContigID | ( | const string & | name | ) | const`[virtual]`

  | Get a contig index by name. If the source does not contain a contig by the specified name GetContigID returns UINT32_MAX. Parameters:
  name | The name of the contig to look for.
Returns: The index of the named contig or UINT32_MAX. Implements gnBaseSource. Definition at line 52 of file gnDNXSource.cpp. References gnBaseSpec::GetName(), gnGenomeSpec::GetSpec(), gnGenomeSpec::GetSpecListLength(), m_DNXSpec, and uint32.

uint32 gnDNXSource::GetContigListLength | ( |  | ) | const`[inline, virtual]`

| Get the number of sequence contigs in this source. Returns: The number of contigs in this source. Implements gnBaseSource. Definition at line 107 of file gnDNXSource.h. References gnGenomeSpec::GetSpecListLength(), m_DNXSpec, and uint32.

string gnDNXSource::GetContigName | ( | const uint32 | i | ) | const`[virtual]`

  | Get the name of the specified contig. Returns an empty string if the specified contig is out of range. Parameters:
  i | The index of the contig or ALL_CONTIGS.
Returns: The name of the contig or an empty string. Implements gnBaseSource. Definition at line 60 of file gnDNXSource.cpp. References gnBaseSpec::GetName(), gnGenomeSpec::GetSpec(), gnGenomeSpec::GetSpecListLength(), and m_DNXSpec.

gnSeqI gnDNXSource::GetContigSeqLength | ( | const uint32 | i | ) | const`[virtual]`

  | Get the total number of base pairs in the specified contig. Parameters:
  i | The index of the contig or ALL_CONTIGS.
Returns: The length in base pairs of the specified contig. Implements gnBaseSource. Definition at line 68 of file gnDNXSource.cpp. References gnBaseSpec::GetLength(), gnMultiSpec::GetLength(), gnGenomeSpec::GetSpec(), gnGenomeSpec::GetSpecListLength(), gnSeqI, and m_DNXSpec.

gnFileContig * gnDNXSource::GetFileContig | ( | const uint32 | contigI | ) | const`[virtual]`

| Returns a pointer to the file contig corresponding to contigI or null if none exists. Implements gnFileSource. Definition at line 136 of file gnDNXSource.cpp.

const gnFilter * gnFileSource::GetFilter | ( |  | ) | const`[inline, virtual, inherited]`

| Get the filter currently being used to filter unwanted characters out of read sequences. Returns: A pointer to the gnFilter currently in use. Implements gnBaseSource. Definition at line 68 of file gnFileSource.h. References gnFileSource::m_pFilter.

string gnFileSource::GetOpenString | ( |  | ) | const`[inline, virtual, inherited]`

| Get the location of the source that is being used. Returns: The location string describing this source, usually a file name. Implements gnBaseSource. Definition at line 62 of file gnFileSource.h. References gnFileSource::m_openString.

gnGenomeSpec * gnDNXSource::GetSpec | ( |  | ) | const`[inline, virtual]`

| Get the annotated sequence data as a gnGenomeSpec. GetSpec returns a gnGenomeSpec which contains the sequence, header, and feature data contained by this source. Returns: The annotated sequence data. Implements gnBaseSource. Definition at line 127 of file gnDNXSource.h. References gnGenomeSpec::Clone(), and m_DNXSpec.

boolean gnDNXSource::HasContig | ( | const string & | name | ) | const`[virtual]`

  | Looks for a contig by name. Returns true if it finds the contig, otherwise false. Parameters:
  name | The name of the contig to look for.
Returns: True if the named contig exists, false otherwise. Implements gnBaseSource. Definition at line 44 of file gnDNXSource.cpp. References gnBaseSpec::GetName(), gnGenomeSpec::GetSpec(), gnGenomeSpec::GetSpecListLength(), m_DNXSpec, and uint32.

void gnFileSource::Open | ( |  | ) | `[virtual, inherited]`

  | Opens this source for reading. Exceptions:
  Will | throw a FileNotOpened exception if the file was not found or was not accessible.
Implements gnBaseSource. Definition at line 48 of file gnFileSource.cpp. References FileNotOpened(), gnFileSource::m_ifstream, gnFileSource::m_openString, and Throw_gnEx.

void gnFileSource::Open | ( | string | openString | ) | `[virtual, inherited]`

  | Opens the source given in "openString" for reading. Parameters:
  openString | The name of the source (file, network URL, or database) to open.
  Exceptions:
  Will | throw a FileNotOpened exception if the file was not found or was not accessible. Will propagate a FileUnreadable exception if the file format was invalid.
Implements gnBaseSource. Definition at line 29 of file gnFileSource.cpp. References FileNotOpened(), gnFileSource::m_ifstream, gnFileSource::m_openString, gnFileSource::ParseStream(), and Throw_gnEx.

boolean gnDNXSource::ParseStream | ( | istream & | fin | ) | `[private, virtual]`

| Implements gnFileSource. Definition at line 141 of file gnDNXSource.cpp. References gnSourceFactory::AddPath(), gnSourceFactory::AddSource(), gnFragmentSpec::AddSpec(), gnGenomeSpec::AddSpec(), Array< T >::data, DebugMsg(), gnBaseSource::GetContigID(), getPathString(), gnSourceFactory::GetSourceFactory(), gnFragmentSpec::GetSpecListLength(), GNSEQI_END, m_DNXSpec, gnBaseSpec::SetName(), gnContigSpec::SetSourceName(), gnMultiSpec::SetSourceName(), uint32, and uint64.

boolean gnFileSource::Read | ( | const uint64 | pos,
|  | char * | buf,
|  | uint32 & | bufLen
| ) | `[virtual, inherited]`

  | Gets raw input from this source. Read will attempt to read "bufLen" bytes starting at "pos" directly from the source. It stores the data in "buf", and returns the actual number of bytes read in bufLen. Read will return false if a serious error occurs. Parameters:
  pos | The position in the file to start reading.
  buf | The character array to store data into.
  bufLen | The number of bytes to read.
Returns: True if the operation was successful. Implements gnBaseSource. Definition at line 63 of file gnFileSource.cpp. References gnFileSource::m_ifstream. Referenced by gnRAWSource::SeqRead().

boolean gnDNXSource::SeqRead | ( | const gnSeqI | start,
|  | char * | buf,
|  | uint32 & | bufLen,
|  | const uint32 | contigI = ALL_CONTIGS
| ) | `[inline, virtual]`

  | Gets sequence data from this source. SeqRead will attempt to read "bufLen" base pairs starting at "start", an offset into the sequence. Reading inside a specific contig can be accomplished by supplying the "contigI" parameter with a valid contig index. SeqRead stores the sequence data in "buf" and returns the actual number of bases read in "bufLen". SeqRead will return false if a serious error occurs. Parameters:
  start | The base pair to start reading at.
  buf | The character array to store base pairs into.
  bufLen | The number of base pairs to read.
  contigI | The index of the contig to read or ALL_CONTIGS by default.
Returns: True if the operation was successful. Implements gnBaseSource. Definition at line 113 of file gnDNXSource.h. References m_DNXSpec, and gnMultiSpec::SeqRead().

void gnFileSource::SetFilter | ( | gnFilter * | filter | ) | `[inline, virtual, inherited]`

  | Set the filter that will be used to filter unwanted characters out of the sequence data. Parameters:
  filter | The filter to remove unwanted characters from the sequence.
  Exceptions:
  NullPointer | is thrown if the specified filter pointer is null.
Implements gnBaseSource. Definition at line 74 of file gnFileSource.h. References gnFileSource::m_pFilter, NullPointer(), and Throw_gnEx.

void gnDNXSource::ValidateName | ( | string & | name | ) | `[static, private]`

| Definition at line 80 of file gnDNXSource.cpp. Referenced by Write().

boolean gnDNXSource::Write | ( | gnGenomeSpec * | spec,
|  | const string & | filename
| ) | `[static]`

  | Writes the given gnGenomeSpec to a DNX file named "filename". Actual sequence and annotation data will be written to GenBank files. The DNX file will then reference any created GenBank files. Parameters:
  spec | The spec to write out.
  filename | The name of the file to write.
Returns: True if successful, false otherwise. Definition at line 89 of file gnDNXSource.cpp. References gnBaseHeader::GetHeader(), gnMultiSpec::GetHeader(), gnBaseSpec::GetName(), gnSourceFactory::GetSourceFactory(), gnMultiSpec::GetSourceName(), gnFragmentSpec::GetSpec(), gnGenomeSpec::GetSpec(), gnFragmentSpec::GetSpecListLength(), gnGenomeSpec::GetSpecListLength(), gnSourceFactory::HasSource(), uint32, ValidateName(), and gnGBKSource::Write().

boolean gnDNXSource::Write | ( | gnBaseSource * | source,
|  | const string & | filename
| ) | `[inline, static]`

  | This method is deprecated. Writes the given gnBaseSource to a DNX file named "filename". Actual sequence and annotation data will be written to GenBank files. The DNX file will then reference any created GenBank files. Parameters:
  source | The source to write out.
  filename | The name of the file to write.
Returns: True if successful, false otherwise. Definition at line 123 of file gnDNXSource.h. References gnBaseSource::GetSpec(), and Write().

boolean gnDNXSource::Write | ( | gnSequence & | sequence,
|  | const string & | filename
| ) | `[inline, static]`

  | Writes the given gnSequence to a DNX file named "filename". Actual sequence and annotation data will be written to GenBank files. The DNX file will then reference any created GenBank files. Parameters:
  sequence | The gnSequence to write out.
  filename | The name of the file to write.
Returns: True if successful, false otherwise. Definition at line 119 of file gnDNXSource.h. References gnSequence::GetSpec(). Referenced by Write().

## Member Data Documentation

gnGenomeSpec* gnDNXSource::m_DNXSpec`[private]`

| Definition at line 97 of file gnDNXSource.h. Referenced by GetContigID(), GetContigListLength(), GetContigName(), GetContigSeqLength(), GetSpec(), gnDNXSource(), HasContig(), ParseStream(), SeqRead(), and ~gnDNXSource().

ifstream gnFileSource::m_ifstream`[protected, inherited]`

| Definition at line 53 of file gnFileSource.h. Referenced by gnFileSource::Close(), gnFileSource::DetermineNewlineType(), gnFileSource::gnFileSource(), gnFileSource::Open(), gnSEQSource::ParseStream(), gnRAWSource::ParseStream(), gnGBKSource::ParseStream(), gnFASSource::ParseStream(), gnFileSource::Read(), gnSEQSource::SeqRead(), gnGBKSource::SeqRead(), gnFASSource::SeqRead(), gnSEQSource::SeqStartPos(), gnGBKSource::SeqStartPos(), gnFASSource::SeqStartPos(), gnABISource::~gnABISource(), ~gnDNXSource(), gnFASSource::~gnFASSource(), gnGBKSource::~gnGBKSource(), gnRAWSource::~gnRAWSource(), and gnSEQSource::~gnSEQSource().

uint32 gnFileSource::m_newlineSize`[protected, inherited]`

| Definition at line 56 of file gnFileSource.h. Referenced by gnFileSource::DetermineNewlineType(), gnFileSource::gnFileSource(), gnGBKSource::ParseStream(), gnFASSource::ParseStream(), and gnGBKSource::SeqStartPos().

gnNewlineType gnFileSource::m_newlineType`[protected, inherited]`

| Definition at line 55 of file gnFileSource.h. Referenced by gnFileSource::DetermineNewlineType(), and gnFileSource::gnFileSource().

string gnFileSource::m_openString`[protected, inherited]`

| Definition at line 52 of file gnFileSource.h. Referenced by gnFileSource::GetOpenString(), gnABISource::gnABISource(), gnFASSource::gnFASSource(), gnFileSource::gnFileSource(), gnGBKSource::gnGBKSource(), gnRAWSource::gnRAWSource(), gnSEQSource::gnSEQSource(), and gnFileSource::Open().

const gnFilter* gnFileSource::m_pFilter`[protected, inherited]`

| Definition at line 54 of file gnFileSource.h. Referenced by gnFileSource::GetFilter(), gnABISource::gnABISource(), gnDNXSource(), gnFASSource::gnFASSource(), gnFileSource::gnFileSource(), gnGBKSource::gnGBKSource(), gnSEQSource::gnSEQSource(), gnSEQSource::ParseStream(), gnRAWSource::ParseStream(), gnGBKSource::ParseStream(), gnFASSource::ParseStream(), gnSEQSource::SeqRead(), gnGBKSource::SeqRead(), gnFASSource::SeqRead(), gnSEQSource::SeqStartPos(), gnGBKSource::SeqStartPos(), gnFASSource::SeqStartPos(), and gnFileSource::SetFilter().

The documentation for this class was generated from the following files:

- gnDNXSource.h
- gnDNXSource.cpp